#ifndef _VLP_EDITOR_PREFERENCESDIALOG_H
#define _VLP_EDITOR_PREFERENCESDIALOG_H

#include <QtGui/QDialog>
#include <QtCore/QString>

#include "ui/dialogs/PreferencesDialog.h"

/**
 * @file
 */

namespace loglan {
namespace vlp {
namespace dialog {

/**
 * Program Unit Dialog class
 * Displays dialog for generating code template for unit structure
 */
class PreferencesDialog : public QDialog, private Ui::PreferencesDialog {
public:
	/**
	 * Class constructor
	 */
	PreferencesDialog(QWidget * parent = 0);

	/**
	 * Class destuctor
	 */
	~PreferencesDialog();

	/**
	 * Gets compiler path
	 *
	 * @return path to compiler
	 */
	QString getCompilerPath();

	/**
	 * Sets compiler path
	 *
	 * @param path compiler path
	 */
	void setCompilerPath(QString path);

	/**
	 * Gets files path
	 *
	 * @return path to files
	 */
	QString getFilesPath();

	/**
	 * Sets files path
	 *
	 * @param path files path
	 */
	void setFilesPath(QString path);

	/**
	 * Gets gen path
	 *
	 * @return path to gen
	 */
	QString getGenPath();

	/**
	 * Sets gen path
	 *
	 * @param path gen path
	 */
	void setGenPath(QString path);
};

}
}
}

#endif /* _VLP_EDITOR_PREFERENCESDIALOG_H */
