#ifndef _VLP_EDITOR_UNITSTRUCTUREDIALOG_H
#define _VLP_EDITOR_UNITSTRUCTUREDIALOG_H

#include <QtGui/QDialog>
#include <QtCore/QString>

#include "ui/dialogs/UnitStructureDialog.h"

/**
 * @file
 */

namespace loglan {
namespace vlp {
namespace dialog {

/**
 * Program Unit Dialog class
 * Displays dialog for generating code template for unit structure
 */
class UnitStructureDialog : public QDialog, private Ui::UnitStructureDialog {
public:
	/**
	 * Class constructor
	 */
	UnitStructureDialog(QWidget * parent = 0);

	/**
	 * Class destuctor
	 */
	~UnitStructureDialog();

	/**
	 * Gets user-passed unit name
	 *
	 * @return unit name entered in dialog
	 */
	QString getUnitName();

	/**
	 * Gets unit code template
	 * 
	 * @return unit code template with unit name
	 */
	QString getCode();
};

}
}
}

#endif /* _VLP_EDITOR_PROGRAMSTRUCTUREDIALOG_H */
