#ifndef _VLP_KERNEL_OPTIONS_H
#define _VLP_KERNEL_OPTIONS_H

#include <QtGui/QDialog>

#include "ui/dialogs/OptionsDialog.h"

/**
 * @file
 */

namespace loglan {
namespace vlp {
namespace dialog {

/**
 * Options Dialog class
 */
class OptionsDialog : public QDialog, private Ui::OptionsDialog {
	Q_OBJECT
public:
	OptionsDialog(QString configFilePath, QWidget * parent = 0);
	~OptionsDialog();

	void saveConfig(QString fname);
	void saveConfig(const char * fname);

private:
	QString homeDir;

	void loadConfig(const char * fname);

private slots:
	void on_addConnectionButton_clicked();
	void on_delConnectionButton_clicked();
};

}
}
}

#endif /* _VLP_KERNEL_OPTIONS_H */
